VampPluginSDK 2.1

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Hierarchy
- Class Members

Public Attributes
_VampPluginDescriptor Struct Reference

`#include <vamp.h>`

List of all members.

## Public Attributes
unsigned int | vampApiVersion
| API version with which this descriptor is compatible.
const char * | identifier
| Computer-usable name of the plugin.
const char * | name
| Human-readable name of the plugin.
const char * | description
| Human-readable short text about the plugin.
const char * | maker
| Human-readable name of plugin's author or vendor.
int | pluginVersion
| Version number of the plugin.
const char * | copyright
| Human-readable summary of copyright or licensing for plugin.
unsigned int | parameterCount
| Number of parameter inputs.
const VampParameterDescriptor ** | parameters
| Fixed descriptors for parameter inputs.
unsigned int | programCount
| Number of programs.
const char ** | programs
| Fixed names for programs.
VampInputDomain | inputDomain
| Preferred input domain for audio input (time or frequency).
VampPluginHandle(* | instantiate )(const struct _VampPluginDescriptor *, float inputSampleRate)
| Create and return a new instance of this plugin.
void(* | cleanup )(VampPluginHandle)
| Destroy an instance of this plugin.
int(* | initialise )(VampPluginHandle, unsigned int inputChannels, unsigned int stepSize, unsigned int blockSize)
| Initialise an instance following parameter configuration.
void(* | reset )(VampPluginHandle)
| Reset an instance, ready to use again on new input data.
float(* | getParameter )(VampPluginHandle, int)
| Get a parameter value.
void(* | setParameter )(VampPluginHandle, int, float)
| Set a parameter value.
unsigned int(* | getCurrentProgram )(VampPluginHandle)
| Get the current program (if programCount > 0).
void(* | selectProgram )(VampPluginHandle, unsigned int)
| Set the current program.
unsigned int(* | getPreferredStepSize )(VampPluginHandle)
| Get the plugin's preferred processing window increment in samples.
unsigned int(* | getPreferredBlockSize )(VampPluginHandle)
| Get the plugin's preferred processing window size in samples.
unsigned int(* | getMinChannelCount )(VampPluginHandle)
| Get the minimum number of input channels this plugin can handle.
unsigned int(* | getMaxChannelCount )(VampPluginHandle)
| Get the maximum number of input channels this plugin can handle.
unsigned int(* | getOutputCount )(VampPluginHandle)
| Get the number of feature outputs (distinct sets of results).
VampOutputDescriptor *(* | getOutputDescriptor )(VampPluginHandle, unsigned int)
| Get a descriptor for a given feature output.
void(* | releaseOutputDescriptor )(VampOutputDescriptor *)
| Destroy a descriptor for a feature output.
VampFeatureList *(* | process )(VampPluginHandle, const float *const *inputBuffers, int sec, int nsec)
| Process an input block and return a set of features.
VampFeatureList *(* | getRemainingFeatures )(VampPluginHandle)
| Return any remaining features at the end of processing.
void(* | releaseFeatureSet )(VampFeatureList *)
| Release a feature set returned from process or getRemainingFeatures.

## Detailed Description

Definition at line 248 of file vamp.h.

## Member Data Documentation

unsigned int _VampPluginDescriptor::vampApiVersion

API version with which this descriptor is compatible.

Definition at line 251 of file vamp.h.

const char* _VampPluginDescriptor::identifier

Computer-usable name of the plugin.

Must not change. [a-zA-Z0-9_]

Definition at line 254 of file vamp.h.

const char* _VampPluginDescriptor::name

Human-readable name of the plugin.

May be translatable.

Definition at line 257 of file vamp.h.

const char* _VampPluginDescriptor::description

Human-readable short text about the plugin.

May be translatable.

Definition at line 260 of file vamp.h.

const char* _VampPluginDescriptor::maker

Human-readable name of plugin's author or vendor.

Definition at line 263 of file vamp.h.

int _VampPluginDescriptor::pluginVersion

Version number of the plugin.

Definition at line 266 of file vamp.h.

const char* _VampPluginDescriptor::copyright

Human-readable summary of copyright or licensing for plugin.

Definition at line 269 of file vamp.h.

unsigned int _VampPluginDescriptor::parameterCount

Number of parameter inputs.

Definition at line 272 of file vamp.h.

const VampParameterDescriptor** _VampPluginDescriptor::parameters

Fixed descriptors for parameter inputs.

Definition at line 275 of file vamp.h.

unsigned int _VampPluginDescriptor::programCount

Number of programs.

Definition at line 278 of file vamp.h.

const char** _VampPluginDescriptor::programs

Fixed names for programs.

Definition at line 281 of file vamp.h.

VampInputDomain _VampPluginDescriptor::inputDomain

Preferred input domain for audio input (time or frequency).

Definition at line 284 of file vamp.h.

VampPluginHandle(* _VampPluginDescriptor::instantiate)(const struct _VampPluginDescriptor *, float inputSampleRate)

Create and return a new instance of this plugin.

Definition at line 287 of file vamp.h.

void(* _VampPluginDescriptor::cleanup)(VampPluginHandle)

Destroy an instance of this plugin.

Definition at line 291 of file vamp.h.

int(* _VampPluginDescriptor::initialise)(VampPluginHandle, unsigned int inputChannels, unsigned int stepSize, unsigned int blockSize)

Initialise an instance following parameter configuration.

Definition at line 294 of file vamp.h.

void(* _VampPluginDescriptor::reset)(VampPluginHandle)

Reset an instance, ready to use again on new input data.

Definition at line 300 of file vamp.h.

float(* _VampPluginDescriptor::getParameter)(VampPluginHandle, int)

Get a parameter value.

Definition at line 303 of file vamp.h.

void(* _VampPluginDescriptor::setParameter)(VampPluginHandle, int, float)

Set a parameter value.

May only be called before initialise.

Definition at line 306 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getCurrentProgram)(VampPluginHandle)

Get the current program (if programCount > 0).

Definition at line 309 of file vamp.h.

void(* _VampPluginDescriptor::selectProgram)(VampPluginHandle, unsigned int)

Set the current program.

May only be called before initialise.

Definition at line 312 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getPreferredStepSize)(VampPluginHandle)

Get the plugin's preferred processing window increment in samples.

Definition at line 315 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getPreferredBlockSize)(VampPluginHandle)

Get the plugin's preferred processing window size in samples.

Definition at line 318 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getMinChannelCount)(VampPluginHandle)

Get the minimum number of input channels this plugin can handle.

Definition at line 321 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getMaxChannelCount)(VampPluginHandle)

Get the maximum number of input channels this plugin can handle.

Definition at line 324 of file vamp.h.

unsigned int(* _VampPluginDescriptor::getOutputCount)(VampPluginHandle)

Get the number of feature outputs (distinct sets of results).

Definition at line 327 of file vamp.h.

VampOutputDescriptor*(* _VampPluginDescriptor::getOutputDescriptor)(VampPluginHandle, unsigned int)

Get a descriptor for a given feature output.

Returned pointer is valid only until next call to getOutputDescriptor for this handle, or releaseOutputDescriptor for this descriptor. Host must call releaseOutputDescriptor after use.

Definition at line 333 of file vamp.h.

void(* _VampPluginDescriptor::releaseOutputDescriptor)(VampOutputDescriptor *)

Destroy a descriptor for a feature output.

Definition at line 337 of file vamp.h.

VampFeatureList*(* _VampPluginDescriptor::process)(VampPluginHandle, const float *const *inputBuffers, int sec, int nsec)

Process an input block and return a set of features.

Returned pointer is valid only until next call to process, getRemainingFeatures, or cleanup for this handle, or releaseFeatureSet for this feature set. Host must call releaseFeatureSet after use.

Definition at line 344 of file vamp.h.

VampFeatureList*(* _VampPluginDescriptor::getRemainingFeatures)(VampPluginHandle)

Return any remaining features at the end of processing.

Definition at line 350 of file vamp.h.

void(* _VampPluginDescriptor::releaseFeatureSet)(VampFeatureList *)

Release a feature set returned from process or getRemainingFeatures.

Definition at line 353 of file vamp.h.

The documentation for this struct was generated from the following file:

- vamp.h